How to prepare for software engineering internship interview

{ "search-interviews_300x250_right": {"name": "search-interviews_300x250_right","id": "div-AdSlot-l999angv","width": "300","height": "250"}, "search-interviews_300x250_right_bf": {"name": "search-interviews_300x250_right_bf","id": "div-AdSlot-l999angw","width": "300","height": "250"} }

{ "name": "search-interviews_300x250_right_bf", "id": "div-AdSlot-l999angw", "fluid": true }

{ "name": "search-interviews_728x90_bottom","id": "div-AdSlot-BL","width": "728","height": "90", "formFactors": "desktop,tablet" }

418K

Software Engineer Intern interview questions shared by candidates

Top Interview Questions

How to prepare for software engineering internship interview

You have a 100 coins laying flat on a table, each with a head side and a tail side. 10 of them are heads up, 90 are tails up. You can't feel, see or in any other way find out which side is up. Split the coins into two piles such that there are the same number of heads in each pile.

37 Answers

Split into two piles, one with 90 coins and the other with 10. Flip over every coin in the pile with 10 coins. Less

Pick 10 coins from the original 100 and put them in a separate pile. Then flip those 10 coins over. The two piles are now guaranteed to have the same number of heads. For a general solution of N heads and a total of M coins: 1.) Pick any N coins out of the original group and form a second pile. 2.) Flip the new pile of N coins over. Done. Example (N=2, M=6): Original group is HHTTTT (mixed randomly). Pick any two of these and flip them over. There are only three possible scenarios: 1: The two coins you picked are both tails. New groups are {HHTT} {TT} and when you flip the 2nd group you have {HHTT} and {HH}. 2.) The two coins you picked consist of one head and one tail. New groups are {HTTT} and {HT} and when you flip the 2nd group you have {HTTT} and {TH}. 3.) The two coins you picked are both heads. New groups are {TTTT} and {HH} and when you flip the 2nd group you have {TTTT} and {TT}. Less

reading these answers is such a confidence builder.

Show More Responses

How to prepare for software engineering internship interview

An array of 99 elements contains integers from 1 to 100 with one missing element. Find the missing element.

20 Answers

1. calculate the sum of elements in array say SUM 2. sum of numbers 1 to 100 is(n* (n+1))/2 = 5050 when n==100 3. missing element is (5050-SUM) Less

Sum them and then subtract them from 5050. In general, if an array of size n - 1 elements has unique elements from 1 to n, then the missing element can be found by subtracting the sum of the elements in the array from sum(1 ... n) = n * (n + 1) / 2. Alternately, one could use a boolean array of length n with all values set to false and then for each value, set array[val - 1] to true. To find the missing value, scan through the array and find the index which is set to false. Return index + 1. This requires O(n) memory and two passes over an O(n) array (instead of constant memory and one pass), but has the advantage of actually allowing you to verify whether or not the input was well formed. Less

Read the question. Here are the steps to solve it: 1) find the sum of integers 1 to 100 2) subtract the sum of the 99 members of your set 3) the result is your missing element! Very satisfying! Less

Show More Responses

How to prepare for software engineering internship interview

Write some pseudo code to raise a number to a power.

11 Answers

int raise(num, power){ if(power==0) return 1; if(power==1) return num; return(raise(num, power-1)*num); } Less

small mistake function power(x, n) { if n == 1 return x; // Even numbers else if (n%2 == 0) return square( power (x, n/2)); // Odd numbers else return power(x, n-1) * x; } Less

double Power(int x, int y) { double ret = 1; double power = x; while (y > 0) { if (y & 1) { ret *= power; } power *= power; y >>= 1; } return ret; } Less

Show More Responses

How to prepare for software engineering internship interview

Given an array of numbers, replace each number with the product of all the numbers in the array except the number itself *without* using division.

7 Answers

O(size of array) time & space: First, realize that saying the element should be the product of all other numbers is like saying it is the product of all the numbers to the left, times the product of all the numbers to the right. This is the main idea. Call the original array A, with n elements. Index it with C notation, i.e. from A[0] to A[n - 1]. Create a new array B, also with n elements (can be uninitialized). Then, do this: Accumulator = 1 For i = 0 to n - 2: Accumulator *= A[i] B[i + 1] = Accumulator Accumulator = 1 For i = n - 1 down to 1: Accumulator *= A[i] B[i - 1] *= Accumulator Replace A with B It traverses A twice and executes 2n multiplicates, hence O(n) time It creates an array B with the same size as A, hence O(n) temporary space Less

Create two more arrays. One array contains the products of the elements going upward. That is, B[0] = A[0], B[1] = A[0] * A[1], B[2] = B[1] * A[2], and so on. The other array contains the products of the elements going down. That is, C[n] = A[n], C[n-1] = A[n] * A[n-1], and so on. Now A[i] is simply B[i-1] * C[i+1]. Less

Here are my 2 cents to do this in memory without creating temporary arrays. The simple solution , if division was allowed, was multiple all the elements of the array i.e. tolal = A[0]*A[1]]*....*A[n-1] now take a loop of array and update element i with A[i] = toal/A[i] Since division is not allowed we have to simulate it. If we say X*Y = Z, it means if X is added Y times it is equal to Z e.g. 2*3 = 6, which also means 2+2+2 = 6. This can be used in reverse to find how mach times X is added to get Z. Here is my C solution, which take pointer to array head A[0] and size of array as input void ArrayMult(int *A, int size) { int total= 1; for(int i=0; i< size; ++i) total *= A[i]; for(int i=0; i< size; ++i) { int temp = total; int cnt = 0; while(temp) { temp -=A[i]; cnt++; } A[i] = cnt; } } Speed in O(n) and space is O(1) Less

Show More Responses

How to prepare for software engineering internship interview

How many unique handshakes if each person in a group of 10 give handshakes out to each and every other individual. (a) 100 (b) 50 (c) 45 (d) 20 (e) 10

6 Answers

None of those answers are correct. The follow-up question should be are we assuming that each person is only using 1 hand? For example, if everyone is only giving handshakes left to left, or left to right or right to right or right to left? Granted left to right and right to left would be awkward. Less

45. Imagine it as a polygon of side 10. Or draw out triangle, square, pentagon, and see the pattern yourself, if you don't know the algorithm. Less

Show More Responses

How to prepare for software engineering internship interview

Suppose you have a matrix of numbers. How can you easily compute the sum of any rectangle (i.e. a range [row_start, row_end, col_start, col_end]) of those numbers? How would you code this?

7 Answers

Compute the sum of the rectangles, for all i,j, bounded by (i,j), (i,m), (n,j), (n,m), where (n,m) is the size of the matrix M. Call that sum s(i,j). You can calculate s(i,j) by dynamic programming: s(i,j) = M(i,j) + s(i+1,j) + s(i,j+1) - s(i+1,j+1). And the sum of any rectangle can be computed from s(i,j). Less

The answer is already popular in computer vision fields!! It is called integral imaging. See this page http://en.wikipedia.org/wiki/Haar-like_features Less

Show More Responses

How to prepare for software engineering internship interview

What sort would you use if you required tight max time bounds and wanted highly regular performance.

6 Answers

Merge sort and heapsort are always guaranteed to be n*log(n). Quicksort is usually faster on the average but can be as bad as O(n^2), although with very low probability. Heapsort also does it sorting in-place, without needing an extra buffer, like mergesort. Lastly, heapsort is much easier to implement and understand than balancing trees mentioned by earlier posts. Less

That is so say, a "Balanced Tree Sort" is guaranteed to be O(n log n) always.

for something like this you generally want bubble sort or insertion sort. It's not about being fast it's about being consistent. Make it do exactly the same thing every time. Less

Show More Responses

How to prepare for software engineering internship interview

What is a JavaScript callback function?

5 Answers

A callback function is a piece of JavaScript code that executes after the main function that the callback is attached to executes successfully. Less

udaykanth, I would say that a .forEach() would be the most common and most basic use of a callback function. I'm just writing this to help anyone that might have a hard time thinking up a quick example if the come across this question themselves. Example: var numArray = [ 1, 2, 3 ] ; numArray.forEach( function( i ) { console.log( arr[ i - 1 ] ) } ) ; // logs out // 1 // 2 // 3 Less

Is there a front end role at bloomberg. I guess your position must have been labelled software dev right? altho ur a dront end dev Less

Show More Responses

How to prepare for software engineering internship interview

Implement a binary tree and explain it's function

4 Answers

Hi Xin Li, A binary tree is not the same as binary search tree.. A binary tree is a tree in which every node has atmost two children nodes. It is a k-ary tree in which k=2. A complete binary tree is a tree in which all nodes have the same depth. Less

For the love of god I wish I got a problem this easy

Binary Search tree is a storage data structure that allows log(n) insertion time, log(n) search, given a balanced binary search tree. The following implementation assumes an integer bst. There's a million implementations. Just look on wikipedia for search and insert algorithms. Less

Show More Responses

How to prepare for software engineering internship interview

Implement a method to determine whether a string is a palindrome.

4 Answers

Take a string as function parameter. Copy this str value into a new var, then use .reverse() thereupon. Compare the reversed copy back against original string using turnery operator to set resVariable to "true" : "false". Return resVariable. Less

(Using .split(""), as well as .join(""))

const palindrome = (str) => str == str.reversed() palindrome('hello') // false palindrome('eve') // true Less

Show More Responses

See Interview Questions for Similar Jobs

What can I expect from a software engineer internship interview?

What would you say are your greatest strengths in software engineering? What's one area of software engineering in which you'd like to improve? What are your career aspirations as a software engineer? How do you stay up to date on different coding practices?

How do you prepare for an internship interview?

There are some general internship interview tips to keep in mind to feel confident about your interview:.
Familiarize yourself with the industry. ... .
Practice your interview. ... .
Arrive early for your interview. ... .
Dress professionally. ... .
Pay attention to your posture. ... .
Take extra copies of your materials..

How do I prepare for a software engineering job interview?

How to prepare for your software engineering interview:.
Maximize your chances of being shortlisted..
Find out the interview format..
Pick a programming language..
Sharpen your Computer Science fundamentals for interviews..
Practice for the coding interview..
Prepare for the system design interview (for mid/senior levels).

What questions will I be asked in an internship interview?

How to answer common internship interview questions.
#1: Tell us a bit about yourself..
#2: Why have you applied for this internship?.
#3: Why have you applied for an internship at our company?.
#4: Why do you want to work in this industry?.
#5: What are your strengths?.
#6: How do you prioritise your work?.